import array

def make_header(x,y): #4devdide x
	bmp_size=x*y*24
	header_size=54
	file_size=header_size+bmp_size
	d=array.array("B")
	
	#file header
	
	d.append(ord("B"))
	d.append(ord("M"))
	d.fromlist(f(file_size,4))
	d.fromlist(f(0,2))
	d.fromlist(f(0,2))
	d.fromlist(f(header_size,4))
	
	#information header
	d.fromlist(f(40,4))
	d.fromlist(f(x,4))
	d.fromlist(f(y,4))
	d.fromlist(f(1,2))
	d.fromlist(f(24,2))
	d.fromlist(f(0,4))
	d.fromlist(f(bmp_size,4))
	d.fromlist(f(0,16))

	return d
	
	
def f(n,size): #represent n by size-byte
	x=[]
	m=n
	for i in xrange(size):
		x.append(m%256)
		m/=256
	return x

def save_image(x,y,data,filename):
        if len(data)!=3*x*y:raise "error"
        f=open(filename,"wb")
        make_header(x,y).tofile(f)
        data.tofile(f)
        f.close()

        return 0

def test():
        x=800
        y=600
        d=array.array("B")
        for i in xrange(3*x*y):
                d.append(i%256)
        save_image(800,600,d,"test.bmp")






	
